/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.8 Standard
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :
Version :
Date    : 27.06.2011
Author  : F4CG
Company : F4CG
Comments:


Chip type           : ATtiny2313
Clock frequency     : 8,000000 MHz
Memory model        : Tiny
External SRAM size  : 0
Data Stack size     : 32
*****************************************************/

#include <tiny2313.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x50
	.EQU __sm_powerdown=0x10
	.EQU __sm_standby=0x40
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>
#define start PINA.1
#define select PINA.0
#define load_active {PORTD.3=PORTD.5=1; PORTD.4=PORTD.6=0;}
#define load_clr  {PORTD.3=PORTD.5=0; PORTD.4=PORTD.6=1;}
#define byte1 PIND.5

unsigned char t=0;

unsigned int temp,temp1=0;

bit flags_button=0;
bit flags=0;
bit flags_off_button=0;

typedef unsigned char byte;

byte timer_select=0;
byte temp_select=0;
byte sek=0;
byte timer=0;

byte timer_off_button=0;

//byte flags=0;
byte led_buff [3];
 /*
flash byte led_table[17]={   // anode
0b00000011,                   //0
0b10011111,                   //1
0b00100101,                   //2
0b00001101,                   //3
0b10011001,                   //4
0b01001001,                   //5
0b01000001,                   //6
0b00011111,                   //7
0b00000001,                   //8
0b00001001,                   //9
0b11111101,                   // 
0b11111111,                   //
0b11100011,                   // L
0b11100001,                   // t
0b01110001,                   // F
0b11110101,                   // r
0b01100001                    // E
} ;   */

flash byte led_table[17]={     // chatode
0b11111100,                   //0
0b01100000,                   //1
0b11011010,                   //2
0b11110010,                   //3
0b01100110,                   //4
0b10110110,                   //5
0b10111110,                   //6
0b11100000,                   //7
0b11111110,                   //8
0b11110110,                   //9
0b00000010,                   // 
0b00000000,                   //
0b00011100,                   // L
0b00011110,                   // t
0b10001110,                   // F
0b00001010,                   // r
0b10011110                    // E
} ;


// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Reinitialize Timer 0 value
TCNT0=0x9F; // 105
// Place your code here
PORTD.0=1;
PORTD.1=1;
PORTD.2=1;
switch (t)
{
case 0:
PORTD.2=0;

PORTB = led_buff [0];
break;

case 1:
PORTD.1=0;

PORTB = led_buff [1];
break;

case 2:
PORTD.0=0;

PORTB = led_buff [2];
break;
}
 t++;
if (t>2) t=0;
}

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// Input/Output Ports initialization
// Port A initialization
// Func2=Out Func1=In Func0=In
// State2=0 State1=P State0=P
PORTA=0x03;
DDRA=0x04;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
// State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
PORTB=0x00;
DDRB=0xFF;

// Port D initialization
// Func6=Out Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out
// State6=0 State5=P State4=P State3=P State2=0 State1=0 State0=0
PORTD=0b1010000;
DDRD=0b1111111;



// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 7,813 kHz
// Mode: Normal top=FFh
// OC0A output: Disconnected
// OC0B output: Disconnected
TCCR0A=0x00;
TCCR0B=0x04;
TCNT0=0x9F;  //  159    //  068
OCR0A=0x00;
OCR0B=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// Interrupt on any change on pins PCINT0-7: Off
GIMSK=0x00;
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x02;

// Universal Serial Interface initialization
// Mode: Disabled
// Clock source: Register & Counter=no clk.
// USI Counter Overflow Interrupt: Off
USICR=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;

// Global enable interrupts
#asm("sei")

while (1)
      {
      // Place your code here

       if (start==0 && flags_button==0)
        {
         delay_ms(50);
           if (start==0 && flags_button==0)
            {
             if (flags) flags=0; else flags=1;

             flags_button=1;
            }
        }

        if (select==0 && flags_button==0)
        {
         delay_ms(50);
         if (select==0 && flags_button==0)
          {
            timer_off_button++;

             if (timer_off_button > 15)
              {

               timer_select=0;
               flags_off_button=0;
               timer_off_button=0;
               flags_button=1;
              }
               else
               {
                flags_off_button=1;

               }

          }

        }



        if (start && select)
        {
         flags_button=0;
            if(flags_off_button==1)
         {
          if ( timer_select++ == 7 ) {timer_select=0;}
            flags=0;
            temp1=0;
            timer_off_button=0;
            flags_off_button=0;

         }

        }

        if (timer_select == 0)
         {
            led_buff[2]=led_table[14]; //  
            led_buff[1]=led_table[14];
            led_buff[0]=led_table[0];

             load_clr;

         } else if (timer_select == 1)
            {
               temp_select=10;
            } else if (timer_select == 2)
               {
                  temp_select=20;
               } else if (timer_select == 3)
                  {
                     temp_select=30;
                  } else if (timer_select == 4)
                     {
                        temp_select=40;
                     } else if (timer_select == 5)
                        {
                           temp_select=50;
                        } else if (timer_select == 6)
                           {
                            temp_select=60;
                           } else if (timer_select == 7)
                              {
                               timer_select=0;
                              }

          if (timer_select!=0)
         {
           if (temp1<10)
          {

           led_buff[2]=led_table[temp]; //  

           led_buff[1]=led_table[11];

           led_buff[0]=led_table[13];
          }

           if (temp1>9 && temp1<100)
          {
           led_buff[2]=led_table[temp%10]; //  
           temp=temp/10;
           led_buff[1]=led_table[temp%10];

           led_buff[0]=led_table[13];
          }
             if (flags)
              {

               if (sek==0){sek=temp_select; flags=0;}
               if(timer>0){timer--;} else{ timer=50; sek--;}
               temp1=sek;

               load_active;

              }
               else
              {
               if(temp1<temp_select){temp1++;} else{ temp1=temp_select; flags=0;}
               sek=temp_select;

               load_clr;
              }
         }








        delay_ms(20);

       temp = temp1;



      };
}
